<template>
  <div class="m-40 flex justify-center">
    <div
      v-if="
        processState === 'wait for user input' ||
        processState === 'recovery is refused'
      " 
    >
      <div class="header">
        <p class="my-10">
          {{ $t('resetPassword.text') }}
        </p>
      </div>
      <div class="w-full max-w-sm">
        <div class="md:flex md:items-center mb-6">
          <div class="md:w-1/3">
            <label
              class="ada-form-label"
              for="the-page-reset-password--email"
            >
              {{ $t('resetPassword.email') }}
            </label>
          </div>
          <div class="md:w-2/3">
            <input
              v-model="email"
              @keyup.enter="setEmail"
              class="ada-text-input w-full"
              id="the-page-reset-password--email"
              type="text"
            >
          </div>
        </div>
        <div class="md:flex md:items-center">
          <div class="md:w-1/3"></div>
          <div class="md:w-2/3">
            <div>
              <button class="ada-button" type="button" @click="setEmail">
                {{ $t('resetPassword.getLink') }}
              </button>
            </div>
          </div>
        </div>
      </div>
      <div
        class="refused"
        v-if="processState === 'recovery is refused'"
      >
        <p>
          {{ $t('resetPassword.refused') }}
        </p>
        <p class="mt-4">
          {{ $t('resetPassword.refusedMessage') }}
        </p>
      </div>
    </div>
    <div
      class="process-state-message"
      v-if="processState === 'wait for request response'"
    >
      {{ $t('resetPassword.processing') }}
    </div>
    <div
      class="process-state-message"
      v-if="processState === 'recovery is accepted'"
    >
      {{ $t('resetPassword.success') }}
    </div>
  </div>
</template>

<script>
import { ref } from 'vue'
import { useStore } from '../store.js'
import auth from '../auth.js'

export default {
  name: 'ThePageResetPassword',
  setup () {
    const { authentification } = useStore()
    const email = ref('')
    const processState = ref('wait for user input')
    return {
      email,
      authentification,
      processState
    }
  },
  methods: {
    setEmail () {
      this.processState = 'wait for request response'
      auth
        .requestPasswordRecovery(this.email)
        .then((response) => {
          this.processState = 'recovery is accepted'
        })
        .catch((error) => {
          this.processState = 'recovery is refused'
          console.log(
            `error while trying password recovery for email ${this.email}: ${error}`
          )
        })
    }
  }
}
</script>

<style lang="postcss" scoped>
.header {
  @apply m-10 max-w-xl;
  @apply text-xl text-gray-700;
  @apply dark:text-gray-300;
}

.refused {
  @apply m-10 max-w-sm;
  @apply text-base text-center text-gray-700;
  @apply text-gray-400;
}

.process-state-message {
  @apply max-w-sm my-10;
  @apply text-xl text-center text-gray-700;
  @apply dark:text-gray-400;
}
</style>